<template>
    <div>
        <div class="d-flex justify-content-between">
            <div>
                <h1 class="h3 mb-4 text-gray-800">Project</h1>
            </div>
            <div>
                <router-link :to="{ name:'ProjectCreate' }" class="btn btn-success" role="button">Create Project</router-link>
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <search-box v-model="searchValue" delay="500"></search-box>
            </div>
        </div>

        <project-card
            v-for="project in projects"
            :key="project.id"
            :project="project"
        >
        </project-card>

        <div v-if="projects.length == 0" class="card text-black shadow">
            <div class="card-body">
                No Project List
                <div class="text-black-50 small">please create new project</div>
            </div>
        </div>
    </div>
</template>

<script>
import SearchBox from "../../components/SearchBoxComponent";
import ProjectCard from "../../components/project/ProjectCardComponent";
export default {
    components: {
        SearchBox,
        ProjectCard
    },
    data() {
        return {
            projects: [],
            defaultProjects: [],
            searchValue: ""
        };
    },
    created() {
        this.prepare();
    },
    methods: {
        prepare() {
            this.getProjects();
        },
        getProjects() {
            axios
                .get("/api/project/all")
                .then(res => {
                    this.projects = this.defaultProjects = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        searchProject(value) {
            this.projects = _.filter(this.defaultProjects, function(project) {
                return (
                    project.name.toLowerCase().includes(value.toLowerCase()) ||
                    project.location.toLowerCase().includes(value.toLowerCase())
                );
            });
        },
        setDefaultProjects() {
            this.projects = this.defaultProjects;
        }
    },
    watch: {
        searchValue: function(value) {
            if (value) {
                this.searchProject(value);
            } else {
                this.setDefaultProjects();
            }
        }
    }
};
</script>
